# \QueryQueryBuilderInterface

Interface defining the Query Builder class

## Summary

Methods
Constants
select()
selectMax()
selectMin()
selectAvg()
selectSum()
distinct()
explain()
from()
like()
orLike()
notLike()
orNotLike()
having()
orHaving()
where()
orWhere()
whereIn()
orWhereIn()
whereNotIn()
orWhereNotIn()
set()
join()
groupBy()
orderBy()
limit()
groupStart()
notGroupStart()
orGroupStart()
orNotGroupStart()
groupEnd()
get()
getWhere()
countAll()
countAllResults()
insert()
insertBatch()
replace()
update()
updateBatch()
delete()
getCompiledSelect()
getCompiledInsert()
getCompiledUpdate()
getCompiledDelete()
resetQuery()
No constants found
No protected methods found
N/A
No private methods found
N/A

File
  Query/QueryBuilderInterface.php
Package
  \Query\QueryBuilder

## Tags

None found

## Methods

### select()

    select(string  $fields) : \Query\QueryBuilderInterface

Specifies rows to select in a query

#### Parameters

string | $fields |

#### Returns

\Query\QueryBuilderInterface

#

## Tags

None found

### selectMax()

    selectMax(string  $field, string|boolean  $as = FALSE) : \Query\QueryBuilderInterface

Selects the maximum value of a field from a query

#### Parameters

string | $field |
string|boolean | $as |

#### Returns

\Query\QueryBuilderInterface

#

## Tags

None found

### selectMin()

    selectMin(string  $field, string|boolean  $as = FALSE) : \Query\QueryBuilderInterface

Selects the minimum value of a field from a query

#### Parameters

string | $field |
string|boolean | $as |

#### Returns

\Query\QueryBuilderInterface

#

## Tags

None found

### selectAvg()

    selectAvg(string  $field, string|boolean  $as = FALSE) : \Query\QueryBuilderInterface

Selects the average value of a field from a query

#### Parameters

string | $field |
string|boolean | $as |

#### Returns

\Query\QueryBuilderInterface

#

## Tags

None found

### selectSum()

    selectSum(string  $field, string|boolean  $as = FALSE) : \Query\QueryBuilderInterface

Selects the sum of a field from a query

#### Parameters

string | $field |
string|boolean | $as |

#### Returns

\Query\QueryBuilderInterface

#

## Tags

None found

### distinct()

    distinct() : \Query\QueryBuilderInterface

Adds the 'distinct' keyword to a query

#### Returns

\Query\QueryBuilderInterface

#

## Tags

None found

### explain()

    explain() : \Query\QueryBuilderInterface

Shows the query plan for the query

#### Returns

\Query\QueryBuilderInterface

#

## Tags

None found

### from()

    from(string  $tblname) : \Query\QueryBuilderInterface

Specify the database table to select from

#### Parameters

string | $tblname |

#### Returns

\Query\QueryBuilderInterface

#

## Tags

None found

### like()

    like(string  $field, mixed  $val, string  $pos = 'both') : \Query\QueryBuilderInterface

Creates a Like clause in the sql statement

#### Parameters

string | $field |
mixed | $val |
string | $pos |

#### Returns

\Query\QueryBuilderInterface

#

## Tags

None found

### orLike()

    orLike(string  $field, mixed  $val, string  $pos = 'both') : \Query\QueryBuilderInterface

Generates an OR Like clause

#### Parameters

string | $field |
mixed | $val |
string | $pos |

#### Returns

\Query\QueryBuilderInterface

#

## Tags

None found

### notLike()

    notLike(string  $field, mixed  $val, string  $pos = 'both') : \Query\QueryBuilderInterface

Generates a NOT LIKE clause

#### Parameters

string | $field |
mixed | $val |
string | $pos |

#### Returns

\Query\QueryBuilderInterface

#

## Tags

None found

### orNotLike()

    orNotLike(string  $field, mixed  $val, string  $pos = 'both') : \Query\QueryBuilderInterface

Generates a OR NOT LIKE clause

#### Parameters

string | $field |
mixed | $val |
string | $pos |

#### Returns

\Query\QueryBuilderInterface

#

## Tags

None found

### having()

    having(mixed  $key, mixed  $val = array()) : \Query\QueryBuilderInterface

Generates a 'Having' clause

#### Parameters

mixed | $key |
mixed | $val |

#### Returns

\Query\QueryBuilderInterface

#

## Tags

None found

### orHaving()

    orHaving(mixed  $key, mixed  $val = array()) : \Query\QueryBuilderInterface

Generates a 'Having' clause prefixed with 'OR'

#### Parameters

mixed | $key |
mixed | $val |

#### Returns

\Query\QueryBuilderInterface

#

## Tags

None found

### where()

    where(mixed  $key, mixed  $val = array(), boolean  $escape = NULL) : \Query\QueryBuilderInterface

Specify condition(s) in the where clause of a query Note: this function works with key / value, or a passed array with key / value pairs

#### Parameters

mixed | $key |
mixed | $val |
boolean | $escape |

#### Returns

\Query\QueryBuilderInterface

#

## Tags

None found

### orWhere()

    orWhere(string  $key, mixed  $val = array()) : \Query\QueryBuilderInterface

Where clause prefixed with "OR"

#### Parameters

string | $key |
mixed | $val |

#### Returns

\Query\QueryBuilderInterface

#

## Tags

None found

### whereIn()

    whereIn(mixed  $field, mixed  $val = array()) : \Query\QueryBuilderInterface

Where clause with 'IN' statement

#### Parameters

mixed | $field |
mixed | $val |

#### Returns

\Query\QueryBuilderInterface

#

## Tags

None found

### orWhereIn()

    orWhereIn(string  $field, mixed  $val = array()) : \Query\QueryBuilderInterface

Where in statement prefixed with "or"

#### Parameters

string | $field |
mixed | $val |

#### Returns

\Query\QueryBuilderInterface

#

## Tags

None found

### whereNotIn()

    whereNotIn(string  $field, mixed  $val = array()) : \Query\QueryBuilderInterface

WHERE NOT IN (FOO) clause

#### Parameters

string | $field |
mixed | $val |

#### Returns

\Query\QueryBuilderInterface

#

## Tags

None found

### orWhereNotIn()

    orWhereNotIn(string  $field, mixed  $val = array()) : \Query\QueryBuilderInterface

OR WHERE NOT IN (FOO) clause

#### Parameters

string | $field |
mixed | $val |

#### Returns

\Query\QueryBuilderInterface

#

## Tags

None found

### set()

    set(mixed  $key, mixed  $val = NULL) : \Query\QueryBuilderInterface

Sets values for inserts / updates / deletes

#### Parameters

mixed | $key |
mixed | $val |

#### Returns

\Query\QueryBuilderInterface

#

## Tags

None found

### join()

    join(string  $table, string  $condition, string  $type = '') : \Query\QueryBuilderInterface

Creates a join phrase in a compiled query

#### Parameters

string | $table |
string | $condition |
string | $type |

#### Returns

\Query\QueryBuilderInterface

#

## Tags

None found

### groupBy()

    groupBy(mixed  $field) : \Query\QueryBuilderInterface

Group the results by the selected field(s)

#### Parameters

mixed | $field |

#### Returns

\Query\QueryBuilderInterface

#

## Tags

None found

### orderBy()

    orderBy(string  $field, string  $type = "") : \Query\QueryBuilderInterface

Order the results by the selected field(s)

#### Parameters

string | $field |
string | $type |

#### Returns

\Query\QueryBuilderInterface

#

## Tags

None found

### limit()

    limit(integer  $limit, integer|boolean  $offset = FALSE) : \Query\QueryBuilderInterface

Set a limit on the current sql statement

#### Parameters

integer | $limit |
integer|boolean | $offset |

#### Returns

\Query\QueryBuilderInterface

#

## Tags

None found

### groupStart()

    groupStart() : \Query\QueryBuilderInterface

Adds a paren to the current query for query grouping

#### Returns

\Query\QueryBuilderInterface

#

## Tags

None found

### notGroupStart()

    notGroupStart() : \Query\QueryBuilderInterface

Adds a paren to the current query for query grouping, prefixed with 'NOT'

#### Returns

\Query\QueryBuilderInterface

#

## Tags

None found

### orGroupStart()

    orGroupStart() : \Query\QueryBuilderInterface

Adds a paren to the current query for query grouping, prefixed with 'OR'

#### Returns

\Query\QueryBuilderInterface

#

## Tags

None found

### orNotGroupStart()

    orNotGroupStart() : \Query\QueryBuilderInterface

Adds a paren to the current query for query grouping, prefixed with 'OR NOT'

#### Returns

\Query\QueryBuilderInterface

#

## Tags

None found

### groupEnd()

    groupEnd() : \Query\QueryBuilderInterface

Ends a query group

#### Returns

\Query\QueryBuilderInterface

#

## Tags

None found

### get()

    get(string  $table = '', integer|boolean  $limit = FALSE, integer|boolean  $offset = FALSE) : \PDOStatement

Select and retrieve all records from the current table, and/or execute current compiled query

#### Parameters

string | $table |
integer|boolean | $limit |
integer|boolean | $offset |

#### Returns

\PDOStatement

#

## Tags

None found

### getWhere()

    getWhere(string  $table, array  $where = array(), integer|boolean  $limit = FALSE, integer|boolean  $offset = FALSE) : \PDOStatement

Convenience method for get() with a where clause

#### Parameters

string | $table |
array | $where |
integer|boolean | $limit |
integer|boolean | $offset |

#### Returns

\PDOStatement

#

## Tags

None found

### countAll()

    countAll(string  $table) : integer

Retrieve the number of rows in the selected table

#### Parameters

string | $table |

#### Returns

integer

#

## Tags

None found

### countAllResults()

    countAllResults(string  $table = '', boolean  $reset = TRUE) : integer

Retrieve the number of results for the generated query - used in place of the get() method

#### Parameters

string | $table |

boolean

$reset

- Whether to keep the query after counting the results

#### Returns

integer

#

## Tags

None found

### insert()

    insert(string  $table, mixed  $data = array()) : \PDOStatement

Creates an insert clause, and executes it

#### Parameters

string | $table |
mixed | $data |

#### Returns

\PDOStatement

#

## Tags

None found

### insertBatch()

    insertBatch(string  $table, array  $data = array()) : \PDOStatement|null

Creates and executes a batch insertion query

#### Parameters

string | $table |
array | $data |

#### Returns

\PDOStatement|null

#

## Tags

None found

### replace()

    replace(string  $table, array  $data = array()) : \PDOStatement|null

Insertion with automatic overwrite, rather than attempted duplication

#### Parameters

string | $table |
array | $data |

#### Returns

\PDOStatement|null

#

## Tags

None found

### update()

    update(string  $table, mixed  $data = array()) : \PDOStatement

Creates an update clause, and executes it

#### Parameters

string | $table |
mixed | $data |

#### Returns

\PDOStatement

#

## Tags

None found

### updateBatch()

    updateBatch(string  $table, array|object  $data, string  $where) : integer|null

Creates a batch update, and executes it.

Returns the number of affected rows

#### Parameters

string | $table |
array|object | $data |
string | $where |

#### Returns

integer|null

#

## Tags

None found

### delete()

    delete(string  $table, mixed  $where = '') : \PDOStatement

Deletes data from a table

#### Parameters

string | $table |
mixed | $where |

#### Returns

\PDOStatement

#

## Tags

None found

### getCompiledSelect()

    getCompiledSelect(string  $table = '', boolean  $reset = TRUE) : string

Returns the generated 'select' sql query

#### Parameters

string | $table |
boolean | $reset |

#### Returns

string

#

## Tags

None found

### getCompiledInsert()

    getCompiledInsert(string  $table, boolean  $reset = TRUE) : string

Returns the generated 'insert' sql query

#### Parameters

string | $table |
boolean | $reset |

#### Returns

string

#

## Tags

None found

### getCompiledUpdate()

    getCompiledUpdate(string  $table = '', boolean  $reset = TRUE) : string

Returns the generated 'update' sql query

#### Parameters

string | $table |
boolean | $reset |

#### Returns

string

#

## Tags

None found

### getCompiledDelete()

    getCompiledDelete(string  $table = '', boolean  $reset = TRUE) : string

Returns the generated 'delete' sql query

#### Parameters

string | $table |
boolean | $reset |

#### Returns

string

#

## Tags

None found

### resetQuery()

    resetQuery() : void

Clear out the class variables, so the next query can be run

#

## Tags

None found

### QueryBuilderInterface.php